#!/usr/bin/env python
#
# $Id: daemon.py,v 1.1.1.1 2002/06/01 13:43:13 resolve Exp $
#
# Time-stamp: <2002-07-09 08:05:49 resolve>
#
# Copyright (C) Damien Elmes <resolve@repose.cx>, 2001.
# This file is licensed under the GPL. Please see COPYING for more details.
#


"""
desc
"""
import os
import pyosd
import pyosd.daemon
import sys
import string

from twisted.protocols.basic import LineReceiver
from twisted.protocols.protocol import Factory
from twisted.internet import reactor

PYOSD_DIR = os.path.expanduser("~/.pyosd")
PYOSD_SOCKET = os.path.join(PYOSD_DIR, "socket")
MODULES_DIR = os.path.join(PYOSD_DIR, "modules")

if __name__ == "__main__":

    args = []
    kwargs = {'shadow': 0}

    pyosd.daemon.top = apply(pyosd.osd, args, kwargs)
    pyosd.daemon.top.set_pos(pyosd.POS_TOP)
    pyosd.daemon.bot = apply(pyosd.osd, args, kwargs)
    pyosd.daemon.bot.set_pos(pyosd.POS_BOT)

    class PyOSDServ:

        modules = {}

        error = 0
        files = os.listdir(MODULES_DIR)
        for f in files:
            try:
                namespace = {}
                print os.path.join(MODULES_DIR, f)
                execfile(os.path.join(MODULES_DIR, f), namespace)
                c = namespace['plugin']()
            except AssertionError:
                print "Unable to load module: %s" % f
                error=1

            if not error:
                print "Adding plugin: %s" % f
                for k in c.plugin_keys:
                    modules[k] = c

    class PyOSDConn(LineReceiver):

        def __init__(self):
            self.delimiter = "\n"
            pass

        def lineReceived(self, line):

            s = string.split(line)

            if not s:
                print "Not s"
                return

            cmd = s[0]

            if PyOSDServ.modules.has_key(cmd):
                apply(getattr(PyOSDServ.modules[cmd], cmd), s[1:])
            else:
                print "Unknown command: %s" % line


    factory = Factory()
    factory.protocol = PyOSDConn

    pyosd.daemon.reactor = reactor

    reactor.listenTCP(8007, factory, interface='127.0.0.1')
    reactor.run()


